/*
   Copyright (C)  2000    Daniel A. Atkinson
   Copyright (C)  2004    Ivano Primi  <ivano.primi@tin.it>    

   This file is part of the HPA Library.

   The HPA Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The HPA Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the HPA Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.
*/

/*
    Test:  xfrex  xpr2

    Uses:  atox  prxpr

    Input file: data/xfrex.dat
*/
#include <stdio.h>
#include "xpre.h"

int decd=30;

int main(int na,char **av)
{ 
  struct xpr s; int e;
  char str[64]; FILE *fp;

  if(na!=2) { printf("para: data_file\n"); exit(-1);}
  fp=fopen(*++av,"r");
  while(fscanf(fp,"%s",str)!=EOF)
    {
      s=atox(str);
      printf(" s-in="); prxpr(s,decd);

      /* extract exponent of extended precision number */
      s=xfrex(s,&e);
      printf(" exp= %d\n",e);
      printf(" <s>= "); prxpr(s,decd);

      /* restore exponent of extended precision number */
      s=xpr2(s,e);
      printf("  s1= "); prxpr(s,decd);
    }
  return 0;
}
/*  Test output

 s-in=  1.234500000000000000000000000000e+0
 exp= 1
 <s>=   6.172500000000000000000000000000e-1
  s1=   1.234500000000000000000000000000e+0
 s-in= -2.123450987654321000000000000000e+0
 exp= 2
 <s>=  -5.308627469135802500000000000000e-1
  s1=  -2.123450987654321000000000000000e+0
*/
